#!/usr/bin/env perl

	$input_file = shift(@ARGV) or die "Please supply an input file name\n";
	$output_file = shift(@ARGV) or die "Please supply an output file name\n";


	my @pc_violations = ();
	my %violations;

	open(INFILE, "$input_file") or die "Can't open $input_file: $!";

	# read every line from input file
	while(<INFILE>){
		
		# find the pc in the input line
		# convert the pc to decimal and store it as a key of a hash. 
		# The whole violation line is the value of the hash. 
		# NOTE: this will automatically remove violations from the 
		# same pc and will keep only the last one. 
		if(	/pc:\s([1234567890abcdef]+)/){ 
			$violations{ hex($1) } = $_;
		}
		else{
			print "ERROR: bad format of input file. Did not find pc: \n";
		}
	}

	close INFILE;

	# Get the pc's of violations into an array in sorted order
	@pc_violations = sort {$a<=>$b} ( keys %violations );
	my $num = @pc_violations;
	print "Number of unique violations: $num \n";

	# Output the unique and sorted pc's to a file
	open (OUTFILE, ">$output_file") or die "Can't open $output_file: $!";
	foreach (@pc_violations){
		print OUTFILE $violations{$_}; 
	}
	close OUTFILE;
	
