#!/usr/bin/env perl
use warnings;
use strict;
use diagnostics;

# -------------------------------------------------------------
# Global Variables
# -------------------------------------------------------------

# Change the location of PIN to reflect your installation
my $PIN = "/home/dimitrov/Spring2009/pin-2.5-24110-gcc.4.0.0-ia32_intel64-linux/pin";

my $tool = "MyTokensRegCombineDel.so";
my $input_file = "diduce_miss.txt";
my $run_command;

my $run_options;
my $size = 65536;
my $enable_read = 0;
my $enable_log = 0;
my $instrumentation_limit = 50000000;
my $num_divide = 1;
my $num_select = 0;


my @fail_set = ("-- my_bc inputs/bad.b");

# -------------------------------------------------------------
# Function prototypes 
# -------------------------------------------------------------
sub train_and_trigger();
sub cleanup();


# -------------------------------------------------------------
# Main program 
# -------------------------------------------------------------

# Make sure the PIN tools are up to date
#system "cp -u \$PIN/WORK4/$tool .";


train_and_trigger();
cleanup();

# -------------------------------------------------------------
# end of Main program 
# -------------------------------------------------------------



# -------------------------------------------------------------
# Function definitions 
# -------------------------------------------------------------

sub train_and_trigger(){

	print "*" x 50 . "\n";
	print "Trigger bug for each code region\n";
	print "*" x 50 . "\n";

	# Now train the predictors and trigger the bug, for each code region
	for($num_select=0; $num_select<$num_divide; $num_select++){
	

		# restore trained tables
		$run_command = "cp trained.$num_select.diduce_dump.txt diduce_dump.txt";
		print $run_command . "\n";
		system $run_command;

		# triger the bug
		$enable_log = 1;
		$enable_read = 1;
		$run_options = "$PIN -t $tool -ENABLE_SEP 1 -ENABLE_SEP_READ $enable_read ".
		   "-ENABLE_SEP_LOG $enable_log -TOKEN_TABLE_SIZE 4096 ".
		   "-SEP_TABLE_SIZE $size -ENABLE_TOKEN 1 -SEP_DISABLE_LEARNING 1 ".
		   "-VIOLATION_NEWCODE 1 -NO_SHARED_LIBS 0 ".
		   "-SEP_NUM_DIVIDE $num_divide -SEP_NUM_SELECT $num_select ";
		$run_command = $run_options . " " . $fail_set[0];
		print $run_command . "\n";
		system $run_command;

		$run_command = "mv diduce.txt buggy.$num_select.diduce.txt";
		print $run_command . "\n";
		system $run_command;
		$run_command = "mv CrashToken.txt CrashToken.$num_select.diduce.txt";
		print $run_command . "\n";
		system $run_command;
		system 'rm -f diduce_dump.txt';

	}# end for

}# end train_and_trigger


sub cleanup(){
	
	# combine the violations from each code region
	$run_command = "cat buggy.* > diduce.$num_divide.txt";
	print $run_command . "\n";
	system $run_command;

	$run_command = "count_unique_violations.pl diduce.$num_divide.txt diduce.$num_divide.unique.txt";
	print $run_command . "\n";
	system $run_command;

#	$run_command = "rm -f buggy.* diduce.$num_divide.txt sorted_diduce.txt";
#	print $run_command . "\n";
#	system $run_command;

	$run_command = "cat CrashToken.* > diduce.$num_divide.CrashToken.txt";
	print $run_command . "\n";
	system $run_command;
	
#	$run_command = "rm -f CrashToken.*";
#	print $run_command . "\n";
#	system $run_command;
}

